# Multiply prime numbers table

This program prints out a multiplication table of the first N prime numbers.

## Install

From terminal inside root project run:

````
gem build multiply_prime_numbers_table.gemspec
gem install ./multiply_prime_numbers_table-1.0.0.gem
````

Or install directly from ruby gems:

````
gem install multiply_prime_numbers_table
````

Install the dependencies with:

````
bundle install
````

## Run

To run the program:

````
ruby -Ilib ./bin/multiply_prime_numbers_table
````

## Description

* The program runs from the command line and print a table to STDOUT.
* The first row and column of the table have the N primes, with each cell containing the product of the primes for the corresponding row and column.
* Allows the user to specify different table sizes through a command line option. If the option is not used, the table will contain the first 10 primes by default.

## Test

You can run tests with:

````
rake
````

Or

````
rspec
````

## Comments

The complexity of the program is exponential, the bigger N, the more complex the operations will be. To illustrate this matter i add a benchmark report to measure the performance in get_primes method, since it is the method with the highest cyclomatic complexity.

To improve performance, the #get_primes method avoid to check the number if it's negative is 1 or is EVEN distinct of 2. With this considerations allow us to speed up the code and achieve high performance.

Even for this little example having everything in one file doesn’t scale well. Thats why we separate the logic related to prime number and prime array in distinct files.

Also decided to make small methods like #get_cell_size. Each method should make only one task, to simplify the code and allow it to scale. This method returns a number formatted in string, it's very simple but i decided to make it a method because this way is easier to modify. Maybe tomorrow we improve the way we print the table, and need to calculate cell size differently.

Talking about the way it prints the table, i think it can be improve. Maybe give the user some range in between where you ensure that the table will look good or a use gem, but i wanted to use my own code and for this example i think fulfills its mission.
